# 实验2 实验报告

## 实验要求

完成本次布置的4个Web实验，学习python的request库使用。

## 求解思路

### 1.GET

本题简单使用python request的get方法。

阅读题目，推测 get 的 params 段是 `{'what':'flag'}` ，填入程序后果然得到flxg，flxg的前一部分内容是 `this is the easiest flag` 的变形。后边的东西使用 base64 解码并没有得到合适的结果。

### 2.post

类似于上一道题，本题使用 post 方法。

修改上一题的 url 之后把 get 改成 post，修改参数名之后就可与得到 flxg，前一部分是 `post can also pass data` 的变形。

### 3.Uncompleted

这个题看起来不是很简单，我尝试了一定时间才做出来。打开就能看见俄罗斯方块界面，显然是要通关而不是用常规方法通关。

首先我尝试了尽快结束游戏，发现发送了1个get包：

![21](img/21.png)

找源代码的js代码，发现了一个函数叫做 `GetRequest` ，尝试依次运行、解析相关函数，并没有得到对应的解。

后来知道这是一个迷惑函数，在221行发现了一堆奇怪的符号组合：

![22](img/22.png)

后边有很长的一堆奇怪的符号，放进控制台运行发现数字是好几个9；显然我们是很难达到这个数字的。于是尝试直接执行下面的 eval 内容，得到本题的 flxg 值。

### 4.4.3_On_Sale

首先在各种刷新之后会发现一个填写订单，最开始我也没发现要填啥，后来发现好像是前三道题的flxg；但是直接填进去显然赶不上时间。

于是我先提交了一个空的表，发现有一个网络包：

![23](img/23.png)

是一个post包。于是在python代码手动尝试填入对应表单数据的5个字段：

```python
#!/usr/bin/python
import requests

url = 'http://202.38.69.223:32133/check.php?token=xxxxx'
param = {
    'name': '肖玉鹏',
    'number': 'PB20000198',
    'flag1': 'FLXG{Th1S_1S_TH3_xxxx}',
    'flag2': 'FLXG{P0sT_CAN_A1S0_xxxx}',
    'flag3': 'FLXG{EZ_Uncomplexxxx}'
}
response = requests.post(url=url, data=param)
print(response.text)
```

多次调整 url 之后连续运行，终于在某一次输出中找到了对应的 flxg 值。

## 思考题

- 请举出学校网络中3个以GET方式向网站请求数据的例子，并指出其具体发送的变量及其对应的值
  答：经过测试，从 [教务处官网](www.teach.ustc.edu.cn) 点击“综合教务系统”的时候发送了很多 GET 包：

  ![24](./img/24.png)

  图片包含了很多变量和对应的值。

  在点击“统一身份认证登录”的时候也有 GET：

  ![25](img/25.png)

  点击“登录”，也是 GET，甚至还用明文传输密码：

  ![26](img/26.png)

- 请举出学校网络中3个以POST方式向网站请求数据的例子，并指出其具体发送的变量及其对应的值

  答：在 bb 系统点击具体课堂可以发现一个 post：

  ![27](img/27.png)

  内容：

  ![28](img/28.png)

  还是在这个页面：

  ![29](img/29.png)

  点击“课程主页”：

  ![30](img/30.png)

  ![31](img/31.png)

  这个网页多数是 GET，但是也混合有少量的 POST 请求。
