# 实验3 实验报告

## 实验要求

完成本次布置的4个Web实验，学习python的request库使用。

## 求解思路

### 1.猫咪问答

本题考察使用网络工具搜索答案。

1. 陈炜铿学长用来纠正读音的咖啡馆叫什么名字？

   该问题未找到

2. 我们学校是在什么时候正式接入eduroam服务的？

   搜索关键词：`中科大 接入eduroam` 查询到[网站](https://www.edu.cn/xxh/media/zcjd/news/201511/t20151117_1339050.shtml)，根据该网站的指引找到原始新闻时间为 2015-05-08，得到答案

3. LUG协会03年小聚合影中的bladesatan除了bladesatan@gmail.com，还使用过哪个sohu邮箱？

   该问题未找到，尝试：
   - 把瀚海星云的很多内容都给 get 下来并搜索
   - 使用百度/bing/Google 搜索关键词： bladesatan sohu
   - 搜索 LUG 03年小聚的资料

4. 在IETF定义的无限猴子协议套件中,'This is too derivative.'对应的CRITIC拒绝代码是？

   我本以为 chatgpt 应该知道这个问题，询问后回答：

   ```text
   无限猴子协议套件不是IETF定义的标准协议，因此没有针对该协议套件的官方CRITIC拒绝代码。
   ```

   多次调整发问后仍然没有找到（包括使用英文），于是搜索若干关键词后找到了[这个](https://datatracker.ietf.org/doc/rfc2795/)网站，在该网站搜索 `derivative` 可以找到对应代码是 9

   ```text
   看来chatgpt在搜索方面也有这样的局限性，这是我没想到的。
   ```

5. 科大东区石榴园的一块刻着四句诗的石头，从左向右第二句是？

   首先从网上搜索可以搜到这个石头的图片，这是篆体且最左边的一句话看起来是“自强不息”；而所求的这句话应该是自强不息的上一句，一般会是“天行健”，经过对比查到是“天x行健”，中间的字经过网上查询对比得到是“步”字。

6. 科大东区原222宿舍楼被人们称为什么之一？

   ~~管你拆没拆~~直接搜索关键词 `中科大 东区 222` 可以搜到一个介绍“四牌楼”的网站。

7. 陈炜铿在科大的总GPA是多少？

   直接搜索 `陈炜铿 GPA` 可以搜出来他的简历，GPA是 3.99

### 2.美味的Linux

cat ls pwd cd 可以找到 4 个，经过尝试，剩下一个是 ping

根据观察，我本以为这个是重新编译了这些命令，后来发现原来是在 `/etc/profile` 里……

### 3.Free on SAT

首先打开 F12 找到一大段注释，提示需要找到 `git.zip` ，考虑网站运行情况，把url后边改成 git.zip 就可以下载下来。

解压并没有看到文件，想到 `.git` 一般是隐藏文件，于是通过 git reset 两次还原得到第一个 flag

第二个 flag 比较困难。分析网络包和 `function.php` 可以看到， `time` 和 `identify` 变量不同但 md5 画等号。经过网上的查找和尝试，并没有找到 md5 相同的字符串。后来经过查询，PHP 的两个等号不意味着相等，如果 md5 都是 0e 开头则也可以相等。上网搜索了两个这样的字符串，使用 python 发送请求：

```python
import requests

param = {'id': '1', 'identify': '240610708', 'timer': 'QNKCDZO'}
url = 'http://ctf.nbs.jonbgua.com:32109/test.php'

text = requests.get(url=url, params=param)
print(text.text)
```

输出的文本包含 flag 值。

### 4.picpic

第一题：距离拍摄地最近的地铁站是？(提示:四个字)

![32](img/32.png)

第一个汉字我没看出来，百度地图搜索英文也没有搜出来，但是直接搜索英文可以搜到后两个字，再放到百度地图上就可以得到答案。

第二题：拍摄者拍下的河名字是什么？(提示:三个字)

~~我太熟悉了，本来还有俩选项，看到提示还是三个字，那必然是秦淮河~~

![33](img/33.png)

图片右边有“江南贡院码头”，根据历史知识可知，江南贡院在南京；根据地理知识可知，南京主城区知名主要河流除了长江就只有秦淮河了，该地点是秦淮河。

第三题：这个拍摄地在哪个区？(提示:三个字)

~~我太熟悉了，我高中旁边，我每周都走这过，还画过素描~~

路牌上写着金梭路和雪松路，百度地图搜索知这两条道路的交叉口仅在郑州市中原区（高新区）出现。另外，那棵斜着的树是郑州市高新区的一个并不为人广泛知道的标志。

## 思考题

答：考虑实际情况，.cn 是国内自己管理的，而 .edu 是美国公司管理的，这样使用 .edu 所需要的手续就比较复杂，因此使用 .cn 结尾办理相对简单。

而且考虑实际大学情况，很多大学用3-4个字母作为简称，且一般结尾为U（中科大除外），这样只有 2-3 个字母的有效简称，如果都使用 .edu 则很容易产生简称碰撞。除了美国，大多数国家和地区的高校都主要使用 `.edu.${地区域名}` 的结尾。

另外，www.ustc.edu 指向 www.ustc.edu.cn，说明也有学校用这样的方式申请多个域名并运营。

`.edu` 在域名解析的时候直接作为顶级域名解析，而 `.edu.cn` 则首先解析到 `.cn` 再到 `.edu`
