# 实验9

## 题目1 我们都有光明的未来

直接逆向可以看到有一个 flag，不过看起来这并不是我们想要的。

![1](img/91.png)

观察代码，我意识到这个很可能是大写与小写的相互转换。在做了对应转换之后，我成功获得了 flag 的值。

## 題目2 弟弟在传小纸条

首先先把数据搞出来：

```C
char cypher[] = "qY01NJOFgO$FUlF#q$K[F_9@ccoFO)KK/q`Qe";
char origin_table[] = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ!\"#";
char note_table[] = {
    0x4F, 0x60, 0x43, 0x4B, 0x23, 0x2F, 0x77, 0x29, 0x52, 0x51, 0x30, 0x6B,
    0x39, 0x42, 0x61, 0x71, 0x31, 0x40, 0x41, 0x47, 0x0C, 0x59, 0x2C, 0x67,
    0x63, 0x20, 0x38, 0x5B, 0x6A, 0x24, 0x36, 0x78, 0x3E, 0x0A, 0x72, 0x5A,
    0x62, 0x70, 0x2B, 0x4A, 0x5C, 0x57, 0x55, 0x25, 0x22, 0x21, 0x34, 0x6F,
    0x53, 0x3B, 0x6C, 0x7B, 0x2A, 0x32, 0x5F, 0x69, 0x73, 0x79, 0x54, 0x74,
    0x75, 0x58, 0x6D, 0x27, 0x9,  0x49, 0x50, 0x7C, 0x4D, 0x0D, 0x3F, 0x28,
    0x76, 0x37, 0x6E, 0x64, 0x7A, 0x5D, 0x3D, 0x2D, 0x3C, 0x45, 0x66, 0x2E,
    0x5E, 0x35, 0x33, 0x26, 0x46, 0x68, 0x4E, 0x3A, 0x65, 0x7E, 0x56, 0x4C,
    0x0B, 0x7D, 0x48, 0x44};
```

后边加上从 IDA 发现的函数 `size_t __cdecl index_(char *Str, int a2)` 和 `int __cdecl translate(char *a1)`，编写自己的 main 函数：

```C
for (int i = 0; i < strlen(cypher); i++)
    for (int j = 0; j < strlen(note_table); j++) // j=v1
        if (note_table[j] == cypher[i]) putchar(origin_table[j]);
```

我得到了这个结果：

```text
flagD0n0tGO4ft3rSchooL07335f19
```

看起来很像样，不过答案不对，我以为是某些符号在translate 被丢失了。不过查看二进制代码，我感觉 `origin_table` 应该没那么简单。

![2](img/92.png)

可见其实后边还跟着一堆字母，想尽办法把它拼到 `origin_table` 后边：

```C
char origin_table[] =
    "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRST"
    "UVWXYZ!\"#$%&\x27()*+,-./:;<=>?@[\\]^_`{|}~ \09\x0A";
```

这次就能得到结果：

```text
flag{D0_n0t_GO_4ft3r_SchooL_07335f19}
```

~~*放学别走*~~

## 题目3 妹妹在数羊

经过各种折腾，发现其实本质是有 46 个超级巨大的字符串，然后要求 flag 的每一个字符的 ASCII 必须和对应的字符串的 `sheep` 数量相等。

首先我先把 IDA 对应的数据区的内容想办法复制下来，放到 `test.txt` 里，然后通过一路 `ctrl+H` 去掉了各种杂七杂八的东西。但是考虑到每个字符串内部没有字符 0，于是我把每个字符串后面紧跟的一个 offset0 的 0 保留下来，最后整理成了一个只有一行但是超级长的文本文件 `test.txt`，其中包括 IDA 的字符串数据，不同字符串使用字符 0 分割。接下来运行这个程序：

```python
strs = open('test.txt').read().split('0')
for ss in strs:
    print(chr(ss.count("sheep")), end='')
```

就可以输出结果。

## 题目4 我在写密码学作业

本题目使用 RC4 格密码，该密码具有性质：信息加密后再加密就可以得到原来的信息。

首先先通过 IDA 把基本数据搞出来：

```C
unsigned char enc_buf[] = {
    0x8A, 0x3D, 0x75, 0xAA, 0x2C, 0xCF, 0x9E, 0xCB, 0x7D, 0xE9, 0xF7, 0xCC,
    0x1F, 0x74, 0x12, 0x75, 0x73, 0x4A, 0x3C, 0x2B, 0x0F, 0xF5, 0xED, 0x16,
    0x9E, 0xEE, 0x2F, 0x57, 0xB3, 0x8B, 0xB4, 0x70, 0x80, 0xE7, 0xCD, 0xCF,
    0x7B, 0xCD, 0x56, 0x9C, 0x9B, 0x26, 0x24, 0x40, 0x56, 0x7D, 0xB8, 0x0};
unsigned char unk_41105B[] = {0x31, 0xFE, 0x31, 0xD4, 0xA6, 0x3E, 0x36, 0x6,
                              0xE4, 0x76, 0x0C, 0x12, 0x9C, 0x4E, 0xF6, 0xF5};
```

再把代码搞出来。直接用第二个变量初始化之后对第一个加密，应该能得到结果。

但是实际上并没有得到结果。我猜是因为我的 RC4 代码用了题目中的代码的原因，替换为 IDA 中的代码即可。不过 IDA 中的代码并不容易通过编译，需要进行一定量的修改。最后能够得到对应的 flag 内容。

![3](img/93.png)

## 题目5 你在写信号与系统作业

我没有学过信号与系统，不过可以尝试先把代码搞定。IDA 解出来的结果并不是很如意，我做了一定的解释、修改，包括变量重命名、添加了 free 函数等等之后可以看出来它大概长这个样：

```c
#include <stdio.h>
#include <string.h>
int cipher[104] = {0x20AC, 0x3E16, 0x5E72, 0x7AE9, 0xA187, 0xBD6E, 0xC97C, 0xCEFC, 0xC904,
                   0xCA89, 0xB416, 0xB70C, 0xB807, 0xC8F1, 0xB0A0, 0xB924, 0xB988, 0xCF23,
                   0xB6FC, 0xBB7F, 0xBCB5, 0xBC1A, 0xC14B, 0xBAF2, 0xB4B6, 0xAED1, 0xB40A,
                   0xAE3F, 0xC180, 0xB9C1, 0xC3E9, 0xD30A, 0xD11A, 0xD071, 0xC208, 0xC55B,
                   0xBC72, 0xAB08, 0xA92A, 0xB3A6, 0xACA5, 0xB7DD, 0xBC82, 0xA0FC, 0x920A,
                   0x6E84, 0x572D, 0x42F1, 0x21B1};
int* convolute(char* a1, const char* Str) {
    int  len_Str = strlen(Str);
    int  len_a1  = strlen(a1);
    int* temp_space = (int*)malloc(sizeof(int) * (2 * len_Str + len_a1 - 2));
    int  i = 0;
    // temp_space 仅有第二段是 a1
    for (i = 0; i < (len_Str - 1); ++i) temp_space[i] = 0;
    while (i < (len_Str + len_a1 - 1)) {
        temp_space[i] = a1[i - len_Str + 1];
        ++i;
    }
    while (i < (2 * len_Str + len_a1 - 2)) temp_space[i++] = 0;
    // result_space
    int* result_space = (int*)malloc(sizeof(int) * (len_Str + len_a1 - 1));
    for (int j = 0; j < (int)(len_Str + len_a1 - 1); ++j) {
        int sum = 0;
        for (int k = 0; k <= 6; ++k) sum += temp_space[j + k] * Str[k];
        result_space[j] = sum;
    }
    free(temp_space);
    return result_space;
}
int main(int argc, const char** argv, const char** envp) {
    char input[64];
    printf("Input your flag:");
    scanf("%50s", input);
    int* result = convolute(input, "ESREVER");
    for (int i = 0; i <= 48; ++i) {
        if (result[i] != cipher[i]) {
            printf("Try again\n");
            exit(0);
        }
    }
    free(result);
    printf("You are right\n");
    return 0;
}
```

在这里可以看出来，`convolute` 返回一个数组并且把它的前 49 项和 `cipher` 比对。在第二次循环，也就是给出 `result_space` 的循环中，每一次选取 7 个数字和 `ESREVER` 做数量积。因为我们可以确定前边的 6 项为 0，所以可以利用已有的 `cipher` 反向依次解密。

```cpp
int decrypt() {
    char        result[80]{};
    const char* key = "ESREVER";
    for (int index = 0; index < 48; index++) {
        int sum = 0;
        for (int subindex = 0; subindex < 6; subindex++)
            sum += result[index + subindex] * key[subindex];
        int res           = cipher[index] - sum;
        result[index + 6] = res / 'R';
    }
    printf("%s\n", result + 6);
    return 0;
}
```

然后就可以得到解。

## 练习与思考题

### 0x1

1. 查阅资料，main 函数的前两个参数是什么？

   答：这是用于命令行启动的时候传入命令行参数。argc 是命令行参数的个数，argv 是一个元素为（字符串指针）的数组。以上变量由操作系统分配空间。比如用

   `./executable arg1 "arg2 with space" arg3`

   - `argc` 的值为 4
   - `argv[0]` 为 `./executable`
   - `argv[1]` 为 `arg1`
   - `argv[2]` 为 `arg2 with space`
   - `argv[3]` 为 `arg3`

2. 按照实验一的过程，将如下代码编译生成可执行文件，在 IDA 中查看反编译得到的伪代码。思考：如果不提供源码，只提供编译好的软件，除 IDA + F5 之外，还能想到其他方式获得正确的密码吗？

   答：查看到的界面：

   ![6](img/96.png)

   考虑到 s1 分配了 104 个字节可能是因为我默认 64 位编译。改用 32 位即可看到 s1 为 100；

   其他可行的方式：

   1. 可以使用其他的反汇编工具，比如 objdump 也可以看到汇编代码和字符串的值。这种字符串字面量常量一般在 rodata 里：

      ![95](img/95.png)

   2. 如果使用了 gcc/g++ -g 编译，则可以使用 gdb 在运行的时候设置断点并使用 `p password` 看到密码的值，即便是不提供源代码：

      ![4](img/94.png)

      前提是已经知道了代码的结构，只是不知到字符串的值。

      当然在某些时候还可以直接使用 gdb 修改寄存器的值来输出对应的字符串。

   3. 可以尝试枚举爆破字符串，不过考虑到一些密码往往特别长，所以这一点可能需要花费很长时间。

### 0x2

1. 考虑到 iv 是 unsigned char，所以 python 中需要注意 iv 的变量控制。输出结果为 `reverse_engineering!`

   ```python
   enc = [
       65, 192, 124, 229, 151, 36, 175, 112, 235, 157, 6, 161, 95, 250, 97, 27,
       178, 42, 213, 56
   ]
   iv = 0x33

   for ch in enc:
       chd = ch ^ iv
       print(chr(chd), end='')
       iv = (iv + chd) % 256

   print()
   ```

2. 这个题非常的狡猾，如果直接求解那么需要解一元三次方程。不过考虑到实际情况，有以下方式可解：

   - 方法1：因为 input 的每个值都是 char 类型，因此枚举类型有限，可以考虑打表求解。

     ```python
     enc = [
         1548675, 1083223, 1714875, 1083223, 1548675, 1589169, 1083223, 904309,
         1083223, 1393579, 1147725, 1214739, 1393579, 1083223, 1083223, 1548675,
         1214739, 1393579, 1147725, 42075
     ]
     
     func_chart = {}
     
     
     def func(data: int) -> int:
         return data**3 + 5 * data**2 + 18 * data + 99
     
     
     for data in range(1, 127):
         func_chart[str(func(data))] = data
     
     for data in enc:
         print(chr(func_chart[str(data)]), end='')
     
     print()
     ```

      输出：`reverse_engineering!`

   - 方法2：直接解方程

     可以采取解方程的方式。观察该函数在 x>0 的区间上的值域为正且线性增加，所以可以放心地只取第一个解。这种方法不像上面的方法对枚举数量有限制。

     ```python
     import sympy as sp
     
     enc = [
         1548675, 1083223, 1714875, 1083223, 1548675, 1589169, 1083223, 904309,
         1083223, 1393579, 1147725, 1214739, 1393579, 1083223, 1083223, 1548675,
         1214739, 1393579, 1147725, 42075
     ]
     
     x = sp.Symbol('x')
     
     for data in enc:
         f = x**3 + 5 * x**2 + 18 * x + 99 - data
         result = sp.solve(f)[0]
         print(chr(result), end='')
     
     print()
     ```

     输出：`reverse_engineering!`

3. 输出结果：`666`

   解释：该数字的 16 进制：0x363636，在内存中形成 `[0x36,0x36,0x36,0]` 四个字节，按照字符串翻译就是 `"666"`，所以可以输出 666

   伪代码：

   ![7](img/97.png)

   可以看到它有一定的优化，但是还是不够优化（编译命令：`gcc main.c -g`）。可能和和这里 a 只用于提供字符串信息所以就直接优化了。

   修改之后的运行结果：`666%`（这是linux），结尾因为没有换行符所以多了一个提示。

   IDA 伪代码：

   ![8](img/98.png)

   这里就和原来的代码相差不大。可能因为这里需要 a 提供内存地址所以没有进行对应的优化。
